| Version: 3.0.1

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
wxArtProvider Class Reference
Miscellaneous

`#include <wx/artprov.h>`

Inheritance diagram for wxArtProvider:
[legend]

## Detailed Description

wxArtProvider class is used to customize the look of wxWidgets application.

When wxWidgets needs to display an icon or a bitmap (e.g. in the standard file dialog), it does not use a hard-coded resource but asks wxArtProvider for it instead. This way users can plug in their own wxArtProvider class and easily replace standard art with their own version.

All that is needed is to derive a class from wxArtProvider, override either its wxArtProvider::CreateBitmap() and/or its wxArtProvider::CreateIconBundle() methods and register the provider with wxArtProvider::Push():

class MyProvider : public wxArtProvider
{
protected:
wxBitmap CreateBitmap(const wxArtID& id,
const wxArtClient& client,
const wxSize size)
// optionally override this one as well
wxIconBundle CreateIconBundle(const wxArtID& id,
const wxArtClient& client)
{ ... }
};
...
wxArtProvider::Push(new MyProvider);

If you need bitmap images (of the same artwork) that should be displayed at different sizes you should probably consider overriding wxArtProvider::CreateIconBundle and supplying icon bundles that contain different bitmap sizes.

There's another way of taking advantage of this class: you can use it in your code and use platform native icons as provided by wxArtProvider::GetBitmap or wxArtProvider::GetIcon.

# Identifying art resources

Every bitmap and icon bundle are known to wxArtProvider under an unique ID that is used when requesting a resource from it. The ID is represented by the wxArtID type and can have one of these predefined values (you can see bitmaps represented by these constants in the Art Provider Sample):

- `wxART_ERROR`
- `wxART_QUESTION`
- `wxART_WARNING`
- `wxART_INFORMATION`
- `wxART_ADD_BOOKMARK`
- `wxART_DEL_BOOKMARK`
- `wxART_HELP_SIDE_PANEL`
- `wxART_HELP_SETTINGS`
- `wxART_HELP_BOOK`
- `wxART_HELP_FOLDER`
- `wxART_HELP_PAGE`
- `wxART_GO_BACK`
- `wxART_GO_FORWARD`
- `wxART_GO_UP`
- `wxART_GO_DOWN`
- `wxART_GO_TO_PARENT`
- `wxART_GO_HOME`
- `wxART_GOTO_FIRST` (since 2.9.2)

- `wxART_GOTO_LAST` (since 2.9.2)
- `wxART_PRINT`
- `wxART_HELP`
- `wxART_TIP`
- `wxART_REPORT_VIEW`
- `wxART_LIST_VIEW`
- `wxART_NEW_DIR`
- `wxART_FOLDER`
- `wxART_FOLDER_OPEN`
- `wxART_GO_DIR_UP`
- `wxART_EXECUTABLE_FILE`
- `wxART_NORMAL_FILE`
- `wxART_TICK_MARK`
- `wxART_CROSS_MARK`
- `wxART_MISSING_IMAGE`
- `wxART_NEW`
- `wxART_FILE_OPEN`
- `wxART_FILE_SAVE`

- `wxART_FILE_SAVE_AS`
- `wxART_DELETE`
- `wxART_COPY`
- `wxART_CUT`
- `wxART_PASTE`
- `wxART_UNDO`
- `wxART_REDO`
- `wxART_PLUS` (since 2.9.2)
- `wxART_MINUS` (since 2.9.2)
- `wxART_CLOSE`
- `wxART_QUIT`
- `wxART_FIND`
- `wxART_FIND_AND_REPLACE`
- `wxART_HARDDISK`
- `wxART_FLOPPY`
- `wxART_CDROM`
- `wxART_REMOVABLE`

Additionally, any string recognized by custom art providers registered using wxArtProvider::Push may be used.

Note
  When running under GTK+ 2, GTK+ stock item IDs (e.g. `"gtk-cdrom"`) may be used as well:
  #ifdef __WXGTK__
  wxBitmap bmp = wxArtProvider::GetBitmap("gtk-cdrom", wxART_MENU);
  #endif
  For a list of the GTK+ stock items please refer to the GTK+ documentation page. It is also possible to load icons from the current icon theme by specifying their name (without extension and directory components). Icon themes recognized by GTK+ follow the freedesktop.org Icon Themes specification. Note that themes are not guaranteed to contain all icons, so wxArtProvider may return wxNullBitmap or wxNullIcon. The default theme is typically installed in `/usr/share/icons/hicolor`.

# Clients

The client is the entity that calls wxArtProvider's GetBitmap() or GetIcon() function. It is represented by wxClientID type and can have one of these values:

- `wxART_TOOLBAR`
- `wxART_MENU`
- `wxART_BUTTON`
- `wxART_FRAME_ICON`
- `wxART_CMN_DIALOG`
- `wxART_HELP_BROWSER`
- `wxART_MESSAGE_BOX`
- `wxART_OTHER` (used for all requests that don't fit into any of the categories above)

Client ID serve as a hint to wxArtProvider that is supposed to help it to choose the best looking bitmap. For example it is often desirable to use slightly different icons in menus and toolbars even though they represent the same action (e.g. wxART_FILE_OPEN). Remember that this is really only a hint for wxArtProvider – it is common that wxArtProvider::GetBitmap returns identical bitmap for different client values!

##

Library: wxCore
Category: Miscellaneous

See Also
  Art Provider Sample for an example of wxArtProvider usage; stock ID list

## Public Member Functions

virtual | ~wxArtProvider ()
| The destructor automatically removes the provider from the provider stack used by GetBitmap().
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Static Public Member Functions

static bool | Delete (wxArtProvider *provider)
| Delete the given provider.
static wxBitmap | GetBitmap (const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
| Query registered providers for bitmap with given ID.
static wxIcon | GetIcon (const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
| Same as wxArtProvider::GetBitmap, but return a wxIcon object (or wxNullIcon on failure).
static wxSize | GetNativeSizeHint (const wxArtClient &client)
| Returns native icon size for use specified by client hint.
static wxSize | GetSizeHint (const wxArtClient &client, bool platform_default=false)
| Returns a suitable size hint for the given wxArtClient.
static wxIconBundle | GetIconBundle (const wxArtID &id, const wxArtClient &client=wxART_OTHER)
| Query registered providers for icon bundle with given ID.
static bool | HasNativeProvider ()
| Returns true if the platform uses native icons provider that should take precedence over any customizations.
static void | Insert (wxArtProvider *provider)
static bool | Pop ()
| Remove latest added provider and delete it.
static void | Push (wxArtProvider *provider)
| Register new art provider and add it to the top of providers stack (i.e.
static void | PushBack (wxArtProvider *provider)
| Register new art provider and add it to the bottom of providers stack.
static bool | Remove (wxArtProvider *provider)
| Remove a provider from the stack if it is on it.
static wxArtID | GetMessageBoxIconId (int flags)
| Helper used by GetMessageBoxIcon(): return the art id corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)
static wxIcon | GetMessageBoxIcon (int flags)
| Helper used by several generic classes: return the icon corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)

## Protected Member Functions

virtual wxBitmap | CreateBitmap (const wxArtID &id, const wxArtClient &client, const wxSize &size)
| Derived art provider classes must override this method to create requested art resource.
virtual wxIconBundle | CreateIconBundle (const wxArtID &id, const wxArtClient &client)
| This method is similar to CreateBitmap() but can be used when a bitmap (or an icon) exists in several sizes.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Additional Inherited Members

Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

virtual wxArtProvider::~wxArtProvider | ( |  | ) |

virtual

The destructor automatically removes the provider from the provider stack used by GetBitmap().

## Member Function Documentation

virtual wxBitmap wxArtProvider::CreateBitmap | ( | const wxArtID & | id,
|  | const wxArtClient & | client,
|  | const wxSize & | size
| ) |  |

protectedvirtual

Derived art provider classes must override this method to create requested art resource.

Note that returned bitmaps are cached by wxArtProvider and it is therefore not necessary to optimize CreateBitmap() for speed (e.g. you may create wxBitmap objects from XPMs here).

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap). This only servers as a hint.
  size | Preferred size of the bitmap. The function may return a bitmap of different dimensions, it will be automatically rescaled to meet client's request.

Note
  This is not part of wxArtProvider's public API, use wxArtProvider::GetBitmap or wxArtProvider::GetIconBundle or wxArtProvider::GetIcon to query wxArtProvider for a resource.

See Also
  CreateIconBundle()

virtual wxIconBundle wxArtProvider::CreateIconBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client
| ) |  |

protectedvirtual

This method is similar to CreateBitmap() but can be used when a bitmap (or an icon) exists in several sizes.

static bool wxArtProvider::Delete | ( | wxArtProvider * | provider | ) |

static

Delete the given provider.

static wxBitmap wxArtProvider::GetBitmap | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`,
|  | const wxSize & | size = `wxDefaultSize`
| ) |  |

static

Query registered providers for bitmap with given ID.

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap).
  size | Size of the returned bitmap or wxDefaultSize if size doesn't matter.

Returns
  The bitmap if one of registered providers recognizes the ID or wxNullBitmap otherwise.

static wxIcon wxArtProvider::GetIcon | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`,
|  | const wxSize & | size = `wxDefaultSize`
| ) |  |

static

Same as wxArtProvider::GetBitmap, but return a wxIcon object (or wxNullIcon on failure).

static wxIconBundle wxArtProvider::GetIconBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`
| ) |  |

static

Query registered providers for icon bundle with given ID.

Parameters

  id | wxArtID unique identifier of the icon bundle.
  client | wxArtClient identifier of the client (i.e. who is asking for the icon bundle).

Returns
  The icon bundle if one of registered providers recognizes the ID or wxNullIconBundle otherwise.

static wxIcon wxArtProvider::GetMessageBoxIcon | ( | int | flags | ) |

static

Helper used by several generic classes: return the icon corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)

static wxArtID wxArtProvider::GetMessageBoxIconId | ( | int | flags | ) |

static

Helper used by GetMessageBoxIcon(): return the art id corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)

static wxSize wxArtProvider::GetNativeSizeHint | ( | const wxArtClient & | client | ) |

static

Returns native icon size for use specified by client hint.

If the platform has no commonly used default for this use or if client is not recognized, returns wxDefaultSize.

Note
  In some cases, a platform may have several appropriate native sizes (for example, wxART_FRAME_ICON for frame icons). In that case, this method returns only one of them, picked reasonably.

Since
  2.9.0

static wxSize wxArtProvider::GetSizeHint | ( | const wxArtClient & | client,
|  | bool | platform_default = `false`
| ) |  |

static

Returns a suitable size hint for the given wxArtClient.

If platform_default is true, return a size based on the current platform using GetNativeSizeHint(), otherwise return the size from the topmost wxArtProvider. wxDefaultSize may be returned if the client doesn't have a specified size, like wxART_OTHER for example.

See Also
  GetNativeSizeHint()

static bool wxArtProvider::HasNativeProvider | ( |  | ) |

static

Returns true if the platform uses native icons provider that should take precedence over any customizations.

This is true for any platform that has user-customizable icon themes, currently only wxGTK.

A typical use for this method is to decide whether a custom art provider should be plugged in using Push() or PushBack().

Since
  2.9.0

static void wxArtProvider::Insert | ( | wxArtProvider * | provider | ) |

static

Deprecated:
  Use PushBack() instead.

static bool wxArtProvider::Pop | ( |  | ) |

static

Remove latest added provider and delete it.

static void wxArtProvider::Push | ( | wxArtProvider * | provider | ) |

static

Register new art provider and add it to the top of providers stack (i.e.

it will be queried as the first provider).

See Also
  PushBack()

static void wxArtProvider::PushBack | ( | wxArtProvider * | provider | ) |

static

Register new art provider and add it to the bottom of providers stack.

In other words, it will be queried as the last one, after all others, including the default provider.

See Also
  Push()

Since
  2.9.0

static bool wxArtProvider::Remove | ( | wxArtProvider * | provider | ) |

static

Remove a provider from the stack if it is on it.

The provider is not deleted, unlike when using Delete().